/*******************************************************************************
 * Copyright 2008, 2012 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package kdo.ebn;

/**
 * Interface to access all behaviors of the agent
 */
public interface IEBNAction {
	/**
	 * Called to perform the behavior
	 */
	void perform();

	/**
	 * Retrieve the behavior name
	 *
	 * @return Behavior name
	 */
	String getName();

	/**
	 * Check if this behavior is finished performing
	 *
	 * @return True if finished, false if not
	 */
	boolean isFinished();

	/**
	 * @return the intensity with which to perform the behavior.
	 */
	float getIntensity();

	/**
	 * @param intensity the intensity with which to perform the behavior. Values
	 *        are free to use, but are typically in the range of [0..1]
	 */
	void setIntensity(float intensity);
}
