/*******************************************************************************
 * Copyright 2008, 2012 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package kdo.ebnDevKit.ebnAccess;

/**
 * interface to an activation flow
 * @author Thomas Rinklin
 */
public interface IEbnActivationFlow {
	/**
	 * @return excitation (true) or inhibition (false)
	 */
	boolean isExcitation();

	IEbnCompetence getTargetCompetence();

	/**
	 * interface to an activation flow between competences
	 * @author Thomas Rinklin
	 */
	public interface IEbnCompetenceActivationFlow extends IEbnActivationFlow {
		IEbnCompetence getSourceCompetence();
	}

	/**
	 * interface to an activation flow from a goal to a competence
	 * @author Thomas Rinklin
	 */
	public interface IEbnGoalActivationFlow extends IEbnActivationFlow {
		IEbnGoal getSourceGoal();
	}
}