/*******************************************************************************
 * Copyright 2008, 2012 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package kdo.ebnDevKit.ebnAccess;

import java.util.Iterator;

import kdo.ebnDevKit.ebnAccess.IEbnPerception.IEbnProposition;

/**
 * interface to a goal
 * @author Thomas Rinklin
 */
public interface IEbnGoal {
	String getName();

	int getIndex();

	double getActivation();

	/**
	 * returns situation independent importance
	 * @return situation independent importance
	 */
	double getImportance();

	double getRelevance();

	double getGoalConditionTruthValue();

	IEbnProposition getGoalCondition();

	Iterator<? extends IEbnProposition> getRelevanceConditions();

	/**
	 * checks if the perception is used by the goal
	 * @param perception perception to check
	 * @return true if it's used, false if not
	 */
	boolean isPerceptionUsed(IEbnPerception perception);
}