/*******************************************************************************
 * Copyright 2008, 2012 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package kdo.ebnDevKit.ebnAccess.impl.elements;

import kdo.ebnDevKit.ebnAccess.IEbnPerception.IEbnEffect;

/**
 * represents an effect
 * @author Thomas Rinklin
 */
public class EbnEffect extends EbnProposition implements IEbnEffect
{
	/** probability on which the effect comes true */
	private final double probability;

	/**
	 * constructor
	 * @param ebnPerception reference to the underlying proposition
	 * @param negated if the proposition is negated
	 * @param probability probability on which the effect comes true
	 */
	public EbnEffect(EbnPerception ebnPerception, boolean negated, double probability)
	{
		super(ebnPerception, negated);
		this.probability = probability;
	}

	@Override
	public double getProbability()
	{
		return probability;
	}
}
