/*******************************************************************************
 * Copyright 2008, 2012 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package kdo.ebnDevKit.ebnAccess.impl.elements;

import kdo.ebn.IResourceBelief;
import kdo.ebn.Resource;
import kdo.ebnDevKit.ebnAccess.IEbnResource;

/**
 * represents a resource
 * @author Thomas Rinklin
 */
public class EbnResource implements IEbnResource
{
	/** link to the resource */
	private final Resource resource;

	/**
	 * constructor
	 * @param resource link to the resource
	 */
	public EbnResource(Resource resource)
	{
		this.resource = resource;
	}

	@Override
	public boolean isResource(IResourceBelief iResourceBelief)
	{
		return (resource.getBeliefLink() == iResourceBelief);
	}

	@Override
	public String getName()
	{
		return resource.getName();
	}

	@Override
	public int getAmountAvailable()
	{
		return resource.getAmountAvailable();
	}

	@Override
	public int getMaximalAmount()
	{
		return resource.getMaximalAmount();
	}

	/**
	 * returns the resource
	 * @return the resource
	 */
	public Resource getResource()
	{
		return resource;
	}

	@Override
	public EbnResourceProposition creatProposition(int amountUsed)
	{
		return new EbnResourceProposition(amountUsed, this);
	}
}
