/*******************************************************************************
 * Copyright 2008, 2012 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package kdo.ebnDevKit.ebnAccess.impl.elements;

import kdo.ebnDevKit.ebnAccess.IEbnResource;
import kdo.ebnDevKit.ebnAccess.IEbnResource.IEbnResourceProposition;

/**
 * represents a resource proposition
 * @author Thomas Rinklin
 */
public class EbnResourceProposition implements IEbnResourceProposition
{
	/** amount of resources which are used from this proposition */
	private final int amountUsed;

	/** link to the resource */
	private final EbnResource resource;

	/**
	 *
	 * @param amountUsed amount of resources which are used from this proposition
	 * @param resource link to the resource
	 */
	public EbnResourceProposition(int amountUsed, EbnResource resource)
	{
		super();
		this.amountUsed = amountUsed;
		this.resource = resource;
	}

	@Override
	public boolean isResource(IEbnResource resource)
	{
		return (this.resource == resource);
	}

	@Override
	public IEbnResource getResource()
	{
		return resource;
	}

	@Override
	public int getAmountUsed()
	{
		return amountUsed;
	}
}
