/*******************************************************************************
 * Copyright 2008, 2012 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package kdo.ebnDevKit.genericAgent;

import java.util.List;

import kdo.ebnDevKit.agent.IEbnAgent;
import kdo.ebnDevKit.agent.IEbnAgentCreator;
import kdo.ebnDevKit.agent.util.AgentNameHelper;

/**
 * Creator class for generic agents
 * @author Thomas Rinklin
 */
public class GenericAgentCreator implements IEbnAgentCreator
{
	private final AgentNameHelper nameHelper = new AgentNameHelper();

	private final List<String> behaviors;

	private final List<String> beliefs;

	private final List<String> resources;

	/**
	 * constructor
	 * @param behaviors list of behavior names
	 * @param beliefs list of belief names
	 * @param resources list of resource names
	 */
	public GenericAgentCreator(List<String> behaviors, List<String> beliefs, List<String> resources)
	{
		this.behaviors = behaviors;
		this.beliefs = beliefs;
		this.resources = resources;
	}

	@Override
	public IEbnAgent createAgent()
	{
		return new GenericAgent(nameHelper, behaviors, beliefs, resources);
	}
}
