/*
 * Lecture symbolic AI, FH-Furtwangen
 * Original Author: Klaus Dorer
 */
package kdo.reinforcement;

/**
 * Base class for all TD algorithms providing learning rate update strategy
 *
 * @author KDorer
 */
public abstract class TemporalDifference implements IValueFunctionUpdate
{
	protected ILearnrateStrategy learnrateStrategy;

	public TemporalDifference()
	{
		this(new FixedLearnrate(0.01f));
	}

	public TemporalDifference(ILearnrateStrategy learnrateStrategy)
	{
		this.learnrateStrategy = learnrateStrategy;
	}
}
