package kdo.search.runs.averageOutStrategies;

import java.util.Map;

import kdo.domain.UtilityCalculatorParameters;

public interface IDomainVisitor {
	/**
	 * Called before utility calculation to setup domain specific parameters
	 * @param id the id of this average out run
	 * @return the utility calculator parameters required from the domain
	 */
	UtilityCalculatorParameters createUCParameters(int id);

	/**
	 * Called once oversampling is finished
	 */
	void onFinishedCalculation(Map<String, Double> properties);
}
