/*
 * Lecture symbolic AI, FH-Furtwangen
 * Original Author: Klaus Dorer
 */
package kdo.search.strategy.informed;

import kdo.search.representation.Node;
import kdo.search.strategy.uninformed.NodeUtilitySearch;

/**
 * Represents the A* search strategy
 */
public class AStarSearch extends NodeUtilitySearch
{
	/**
	 * Default constructor
	 */
	public AStarSearch()
	{
		this("A* search");
	}

	/**
	 * constructor with name
	 */
	public AStarSearch(String name)
	{
		super(name, null);
	}

	/**
	 * Determines the value to use as utility function
	 * @param node the node for which we need a utility
	 * @return the utility to be used by the search method
	 */
	@Override
	protected float getUtility(Node node)
	{
		return node.calculateEstimatedCost() + node.getPathCost();
	}
}
