/*
 * Lecture symbolic AI, FH-Furtwangen
 * Original Author: Klaus Dorer
 */
package kdo.search.strategy.informed;

import kdo.search.representation.Node;
import kdo.search.strategy.uninformed.NodeUtilitySearch;

/**
 * Represents the Greedy Search strategy that explores the nodes in order of
 * smallest estimated costs to the goal
 */
public class GreedySearch extends NodeUtilitySearch
{
	/**
	 * Default constructor
	 */
	public GreedySearch()
	{
		super("Greedy search", null);
	}

	/**
	 * Determines the value to use as utility function
	 * @param node the node for which we need a utility
	 * @return the utility to be used by the search method
	 */
	@Override
	protected float getUtility(Node node)
	{
		return node.calculateEstimatedCost();
	}
}
