/* Copyright 2008 - 2017 Hochschule Offenburg
 * For a list of authors see README.md
 * This software of HSOAutonomy is released under MIT License (see LICENSE).
 */

package kdo.search.strategy.local.genetic.fitness;

import java.util.List;

import kdo.domain.IOptimizationState;

/**
 * @author kdorer
 *
 */
public class SerialFitnessCalculator implements IFitnessCalculator
{
	@Override
	public double calculateFitness(List<List<IOptimizationState>> genderStates)
	{
		double sum = 0;
		int n = 0;
		for (List<IOptimizationState> net : genderStates) {
			for (IOptimizationState currentState : net) {
				float fitness = currentState.calculateUtility();
				currentState.setUtility(fitness);
				sum += fitness;
				n++;
			}
		}
		return sum / n;
	}
}
