/*
 * Lecture symbolic AI, FH-Furtwangen
 * Original Author: Klaus Dorer
 */
package kdo.search.strategy.uninformed;

import kdo.search.representation.Node;

/**
 * Represents the Best First Search strategy that explores the nodes in order of
 * smallest path cost
 */
public class BestFirstSearch extends NodeUtilitySearch
{
	/**
	 * Default constructor
	 */
	public BestFirstSearch()
	{
		super("BestFirst search", null);
	}

	/**
	 * Determines the value to use as utility function
	 * @param node the node for which we need a utility
	 * @return the utility to be used by the search method
	 */
	@Override
	protected float getUtility(Node node)
	{
		return node.getPathCost();
	}
}
