/* Copyright 2009 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Rajit Shahi
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package kdo.util.learningParameter;

import kdo.util.parameter.IParameterList;

/**
 *
 * @author kdorer
 */
public interface ILearningParameterList extends IParameterList {
	/**
	 * @return the array of stepSizes for the parameters that are subject to
	 *         learn
	 */
	float[] getStepSizes();

	/**
	 * @return the array of minValues for the parameters that are subject to
	 *         learn
	 */
	float[] getMinValues();

	/**
	 * @return the array of maxValues for the parameters that are subject to
	 *         learn
	 */
	float[] getMaxValues();

	/**
	 * @return the a copy of the array of parameters
	 */
	float[] toChromosom();

	/**
	 * @param chromosom the parameter array to set
	 */
	void fromChromosom(float[] chromosom);

	/**
	 * @return the list decorated by this
	 */
	IParameterList getDecoratedList();
}