/* Copyright 2009 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Rajit Shahi
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package kdo.util.learningParameter;

public class LearningParameter
{
	private boolean shouldBeLearned;

	private float stepSize;

	private final float maxValue;

	private final float minValue;

	public LearningParameter()
	{
		this(false, 1, 0, 1);
	}

	public LearningParameter(boolean shouldBeLearned, float stepSize, float minValue, float maxValue)
	{
		this.shouldBeLearned = shouldBeLearned;
		this.stepSize = stepSize;
		this.minValue = minValue;
		this.maxValue = maxValue;
	}

	@Override
	public String toString()
	{
		return " learn: " + shouldBeLearned + " step: " + stepSize + " minValue: " + minValue +
				" maxValue: " + maxValue;
	}

	public boolean shouldBeLearned()
	{
		return shouldBeLearned;
	}

	public float getStepSize()
	{
		return stepSize;
	}

	public float getMaxValue()
	{
		return maxValue;
	}

	public float getMinValue()
	{
		return minValue;
	}
}
