/* Copyright 2009 Hochschule Offenburg
 * Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber,
 * Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
 * Joachim Schilling, Rajit Shahi
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package kdo.util.learningParameter;

import kdo.util.parameter.Parameter;

public class ParameterDecorator
{
	private Parameter decoratee;

	private LearningParameter learning;

	public ParameterDecorator(Parameter decoratee, LearningParameter learning)
	{
		this.decoratee = decoratee;
		this.learning = learning;
	}

	@Override
	public String toString()
	{
		return decoratee.toString() + learning.toString();
	}

	public String getName()
	{
		return decoratee.getName();
	}

	public float getValue()
	{
		return decoratee.getValue();
	}

	public void setValue(float value)
	{
		decoratee.setValue(value);
	}

	public boolean shouldBeLearned()
	{
		return learning.shouldBeLearned();
	}

	public float getStepSize()
	{
		return learning.getStepSize();
	}

	public float getMaxValue()
	{
		return learning.getMaxValue();
	}

	public float getMinValue()
	{
		return learning.getMinValue();
	}
}
